package com.prettyAccess.rewrite;

import javax.servlet.ServletContext;

import org.ocpsoft.rewrite.config.Configuration;
import org.ocpsoft.rewrite.config.ConfigurationBuilder;
import org.ocpsoft.rewrite.config.Direction;
import org.ocpsoft.rewrite.config.Invoke;
import org.ocpsoft.rewrite.el.El;
import org.ocpsoft.rewrite.servlet.config.HttpConfigurationProvider;
import org.ocpsoft.rewrite.servlet.config.Path;
import org.ocpsoft.rewrite.servlet.config.Redirect;
import org.ocpsoft.rewrite.servlet.config.rule.Join;


public class AccessRewriteConfiguration extends HttpConfigurationProvider {
    @Override
    public Configuration getConfiguration(final ServletContext context) {
        return ConfigurationBuilder.begin()
                .addRule(Join.path("/").to("/index.xhtml"))
                .addRule(Join.path("/about").to("/about.xhtml"))
                .addRule(Join.path("/profile").to("/profile.xhtml"))
                .addRule(Join.path("/login").to("/login.xhtml"))

                
                // Authentication
                .addRule()
                .when(Direction.isInbound().and(Path.matches("/logout")))
                .perform(Invoke.binding(El.retrievalMethod("identity.logout"))
                                .and(Redirect.temporary(context
                                        .getContextPath() + "/")));
    }

    @Override
    public int priority() {
            return 10;
    }
}