package com.prettyAccess.rewrite;

import javax.inject.Inject;
import javax.servlet.ServletContext;

import org.ocpsoft.rewrite.config.Configuration;
import org.ocpsoft.rewrite.config.ConfigurationBuilder;
import org.ocpsoft.rewrite.config.Direction;
import org.ocpsoft.rewrite.context.EvaluationContext;
import org.ocpsoft.rewrite.servlet.config.DispatchType;
import org.ocpsoft.rewrite.servlet.config.HttpCondition;
import org.ocpsoft.rewrite.servlet.config.HttpConfigurationProvider;
import org.ocpsoft.rewrite.servlet.config.Path;
import org.ocpsoft.rewrite.servlet.config.Redirect;
import org.ocpsoft.rewrite.servlet.http.event.HttpServletRewrite;


public class LoginInterceptor extends HttpConfigurationProvider {

	@Inject
	private Identity identity;

	@Override
	public Configuration getConfiguration(ServletContext context) {
	
		return ConfigurationBuilder.begin()
		        .addRule()
		            .when(Direction.isInbound()
		                    .and(DispatchType.isRequest())
				    .andNot(Path.matches("/login"))
				    .andNot(Resources.excluded())
				    .andNot(new HttpCondition() {
				        @Override
				        public boolean evaluateHttp(HttpServletRewrite event, EvaluationContext context) {
				            return identity.isLoggedIn();
				        }
				    }))
				    .perform(Redirect.temporary(context.getContextPath() + "/login"));

	}

	@Override
	public int priority() {
		return 0;
	}
}
